/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <stdlib.h>
#include <time.h>

#include "bos.h"
#include "lldos.h"

#define ADRESA_ROVINY 0xa0000000UL

#define HRACOVE_X 270
#define I_ZEME 190
#define VYSKA_HRACA 20
#define FARBAP 0x4c /* Farba pozadia. */
#define HORNY_OKRAJ 25
#define DLZKA_ZLYCH 10
#define POCET_KLINCOV 15

void vytvorLoptu(unsigned char *lopta)
{
    unsigned int a, b, farba;
    unsigned char farby[5] = {0x20, 0x29, 0x2c, 0x2f, 0x1e};

    memset(lopta, FARBAP, VYSKA_HRACA * VYSKA_HRACA * 5);

    for (a = 0; a < 20; a++)
    {
        if (a > 9) farba = 2;
        else farba = 0;

        if (a == 0) b = 7;
        else if (a == 1) b = 5;
        else if (a == 2) b = 3;
        else if (a < 5) b = 2;
        else if (a < 7) b = 1;
        else if (a < 13) b = 0;
        else if (a < 15) b = 1;
        else if (a < 17) b = 2;
        else if (a == 17) b = 3;
        else if (a < 19) b = 5;
        else b = 7;

        memset(lopta + a * 20 + b, farby[farba], 10 - b);
        memset(lopta + a * 20 + 10, farby[farba + 1], 10 - b);
        /* Duch. */
        memset(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + a * 20 + b,
               farby[4], (10 - b) * 2);
        if (farba == 0)
        {
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA + a * 20 + b,
                   farby[1], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA + a * 20 + 10,
                   farby[3], 10 - b);

            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*2 + a * 20 + b,
                   farby[3], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*2 + a * 20 + 10,
                   farby[2], 10 - b);

            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*3 + a * 20 + b,
                   farby[2], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*3 + a * 20 + 10,
                   farby[0], 10 - b);
        }
        else
        {
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA + a * 20 + b,
                   farby[0], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA + a * 20 + 10,
                   farby[2], 10 - b);

            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*2 + a * 20 + b,
                   farby[1], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*2 + a * 20 + 10,
                   farby[0], 10 - b);

            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*3 + a * 20 + b,
                   farby[3], 10 - b);
            memset(lopta + VYSKA_HRACA*VYSKA_HRACA*3 + a * 20 + 10,
                   farby[1], 10 - b);
        }
    }
    /* Duchove oci. */
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 4 * 20 + 5) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 4 * 20 + 6) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 5 * 20 + 5) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 5 * 20 + 6) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 4 * 20 + 20 - 5) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 4 * 20 + 20 - 6) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 5 * 20 + 20 - 5) = farby[0];
    *(lopta + VYSKA_HRACA*VYSKA_HRACA*4 + 5 * 20 + 20 - 6) = farby[0];

}

void nakresliBlok(unsigned char *obraz, unsigned int x, unsigned int y)
{
    unsigned int i;

    for (i = 0; i < 10; i++)
    {
        memset(obraz + x + (y + i) * 320, 0x6, 10);
    }
}

void nakresliLoptu(unsigned char *obraz,
                   unsigned char *lopta,
                   unsigned int x,
                   unsigned int i)
{
    unsigned int a;

    for (a = 0; a < 20; a++)
    {
        memcpy(obraz + x + (i + a) * 320, lopta + a * 20, 20);
    }
}

void nakresliKlinec(unsigned char *obraz,
                   unsigned int x,
                   unsigned int i)
{
    unsigned int b;

    for (b = 0; b < 10; b++)
    {
        obraz[x + (i + b) * 320] = 0x17;
        if (b == 3 || b == 6) memset(obraz + x + (i + b) * 320 + 1, 0x16, 17);
        else if (b == 4 || b == 5)
        {
            memset(obraz + x + (i + b) * 320 + 1, 0x17, 16);
            memset(obraz + x + (i + b) * 320 + 1 + 16, 0x16, 2);
        }
        else obraz[x + (i + b) * 320 + 1] = 0x16;
    }
}

void nakresliLuc(unsigned char *obraz,
                 unsigned int x,
                 unsigned int i)
{
    memset(obraz + x + (i + 4) * 320 + 1, 0x23, 17);
    memset(obraz + x + (i + 5) * 320 + 1, 0x23, 17);
}

void nakresliSolnyKrystal(unsigned char *obraz,
                          unsigned int x,
                          unsigned int i)
{
    unsigned int b;

    for (b = 0; b < 10; b++)
    {
        if (b == 4 || b == 5)
        {
            memset(obraz + x + (i + b) * 320 + 1,
                   0x23,
                   16);
            memset(obraz + x + (i + b) * 320 + 1 + 16, 0x16, 1);
        }
        else if (b < 5) memset(obraz + x + (i + b) * 320 + 1,
                               b % 2 ? 0x17 : 0x23,
                               (b + 1) * 4);
        else memset(obraz + x + (i + b) * 320 + 1, !(b % 2) ? 0x17 : 0x23,
                    (10 - b) * 4);
    }
}

void nakresliVzdialenost(unsigned char *obraz,
                         unsigned int vzdialenost,
                         unsigned int i)
{
    unsigned int a, b, v = 10;

    for (a = 0; a < 16; a++)
    {
        if (vzdialenost & (1 << a))
        {
            for (b = 0; b < v; b++)
            {
                memset(obraz + (b + i) * 320 + 320 - ((v + 5) * (a + 1)),
                       0x30, v);
            }
        }
        else
        {
            for (b = 0; b < v; b++)
            {
                memset(obraz + (b + i) * 320 + 320 - ((v + 5) * (a + 1)),
                       0x70, v);
            }
        }
    }
}

void prepni_zvuk(unsigned int *zvuk)
{
    *zvuk = !(*zvuk);
    if (*zvuk)
    {
        wportb(0x61, rportb(0x61) | 3);
    }
    else
    {
        wportb(0x61, rportb(0x61) & 0xfc);
    }
}

void hraj_zvuk(unsigned int frekvencia)
{
    unsigned long delitel = 1193180 / frekvencia;
    /* Programovatelny intervalovy casovac, kanal 2. */
    wportb(0x43, 0xb6);
    wportb(0x42, (unsigned char) delitel & 0xff);
    wportb(0x42, (unsigned char) (delitel >> 8));
}

void hraj_zvuk2(unsigned int delitel)
{
    /* Programovatelny intervalovy casovac, kanal 2. */
    wportb(0x43, 0xb6);
    wportb(0x42, (unsigned char) delitel & 0xff);
    wportb(0x42, (unsigned char) (delitel >> 8));
}

/*void nakresliP(unsigned char *obraz,
               unsigned int x,
               unsigned int i,
               unsigned int velkost,
               unsigned char farba)
{
    unsigned int a;

    for (a = 0; a < velkost; a++)
    {
        memset(obraz + (a + i) * 320 + x, farba, velkost * 3);
        memset(obraz + (a + velkost + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost + i) * 320 + x + velkost * 2, farba,
               velkost);
        memset(obraz + (a + velkost*2 + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost*2 + i) * 320 + x + velkost * 2, farba,
               velkost);
        memset(obraz + (a + i + velkost * 3) * 320 + x, farba, velkost * 3);
        memset(obraz + (a + velkost*4 + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost*5 + i) * 320 + x, farba, velkost);
    }
}

void nakresliR(unsigned char *obraz,
               unsigned int x,
               unsigned int i,
               unsigned int velkost,
               unsigned char farba)
{
    unsigned int a;

    for (a = 0; a < velkost; a++)
    {
        memset(obraz + (a + i) * 320 + x, farba, velkost * 3);
        memset(obraz + (a + velkost + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost + i) * 320 + x + velkost * 2, farba,
               velkost);
        memset(obraz + (a + velkost*2 + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost*2 + i) * 320 + x + velkost * 2, farba,
               velkost);
        memset(obraz + (a + i + velkost * 3) * 320 + x, farba, velkost * 3);
        memset(obraz + (a + velkost*4 + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost*4 + i) * 320 + x + velkost * 2, farba,
               velkost);
        memset(obraz + (a + velkost*5 + i) * 320 + x, farba, velkost);
        memset(obraz + (a + velkost*5 + i) * 320 + x + velkost * 2, farba,
               velkost);
    }
}*/

void nakresliZnak(unsigned char *obraz,
               unsigned int x,
               unsigned int i,
               unsigned int velkost,
               unsigned char farba,
               unsigned char *znak)
{
    unsigned int a, b, c;

    for (a = 0; a < 6; a++)
    {
        for (b = 0; b < 6; b++)
        {
            if (znak[a] & (1 << b))
            {
                for (c = 0; c < velkost; c++)
                {
                    memset(obraz + (a * velkost + i + c) * 320 + x + velkost * b,
                           farba,
                           velkost);
                }
            }
        }
    }
}

#define CERVENA 0x29
#define ZELENA 0x30
#define ZLTA 0x2c
#define MODRA 0x20

int main()
{
    unsigned char *obrazovka = (unsigned char *) ADRESA_ROVINY;
    unsigned int cyklus;
    int znak, kod;
    unsigned char *obraz;
    unsigned long cas, stary_cas, uplynuty_cas, skutocny_uplynuty_cas;
    unsigned int polnoc;
    unsigned int logicky_cyklus;
    unsigned int hracove_i;
    unsigned int duch, skok, uz_nikdy_lopta;
    int vrychlost;
    unsigned int a;
    unsigned char *lopta;
    unsigned int rotacia_lopty, spomalenie_rotacie;
    unsigned int x_klincov[POCET_KLINCOV];
    unsigned int i_klincov[POCET_KLINCOV];
    unsigned int r_klincov = 4;
    unsigned int typ_klincov[POCET_KLINCOV];
    unsigned int nove_klince;
    unsigned int prekonane;
    unsigned int spomalenie, pocitadlo_s, zopakovanie;
    unsigned int prehra, koniec = 0, plnenie;
    unsigned int zapnuty_zvuk = 0, ak_zvuk = 0;
    unsigned int hudba2[12] = {2093, 2217, 2349, 2489, 2637, 2794,
                            2960, 3136, 3322, 3520, 3729, 3951};
    unsigned int hudba[12] = {1046, 1109, 1175, 1244, 1328, 1397,
                            2960, 3136, 3322, 3520, 3729, 3951};
    unsigned int prestavka = 0;
    unsigned char znakA[] = {0x1e, 0x33, 0xff, 0x33, 0x33, 0x33};
    unsigned char znakC[] = {0xff, 0x21, 0x1, 0x1, 0x21, 0xff};
    unsigned char znakD[] = {0x0f, 0x1b, 0x33, 0x33, 0x1b, 0x0f};
    unsigned char znakE[] = {0xff, 0x1, 0xf, 0xf, 0x1, 0xff};
    unsigned char znakH[] = {0x33, 0x33, 0xff, 0xff, 0x33, 0x33};
    unsigned char znakI[] = {0xff, 0x0c, 0x0c, 0x0c, 0x0c, 0xff};
    unsigned char znakJ[] = {0x30, 0x30, 0x30, 0x33, 0x33, 0x1e};
    unsigned char znakK[] = {0x33, 0x1b, 0xf, 0xf, 0x1b, 0x33};
    unsigned char znakL[] = {0x3, 0x3, 0x3, 0x3, 0x3, 0xff};
    unsigned char znakM[] = {0x21, 0x33, 0x2d, 0x21, 0x21, 0x21};
    unsigned char znakN[] = {0x21, 0x23, 0x25, 0x29, 0x31, 0x21};
    unsigned char znakO[] = {0xff, 0x33, 0x33, 0x33, 0x33, 0xff};
    unsigned char znakP[] = {0xff, 0x33, 0xff, 0x3, 0x3, 0x3};
    unsigned char znakR[] = {0xff, 0x33, 0xff, 0x0f, 0x1b, 0x33};
    unsigned char znakS[] = {0xff, 0x3, 0xff, 0xff, 0x30, 0xff};
    unsigned char znakT[] = {0xff, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c};
    unsigned char znakU[] = {0x33, 0x33, 0x33, 0x33, 0xff, 0x1e};
    unsigned char znakV[] = {0x33, 0x33, 0x33, 0x33, 0x1e, 0x0c};
    unsigned char znakY[] = {0x33, 0x1e, 0x0c, 0x0c, 0x0c, 0x0c};
    unsigned char znakZ[] = {0xff, 0x30, 0x18, 0xc, 0x06, 0xff};
    unsigned char znakRovnaSa[] = {0x0, 0x0, 0xff, 0x0, 0xff, 0x0};
    unsigned char znakPlus[] = {0x0c, 0x0c, 0xff, 0xff, 0x0c, 0x0c};
    unsigned int velkost_znaku = 3;
    unsigned int x, i;
    unsigned int menu, ako_na_to;

    lopta = malloc(VYSKA_HRACA * VYSKA_HRACA * 5);

    vytvorLoptu(lopta);

    srand(time(0));

    obraz = malloc(320 * 200);

    BosSetVideoMode(0x13);

    prepni_zvuk(&zapnuty_zvuk);

    menu = 1;

    while (!koniec){
    /* RESETOVANIE OBRAZOVKY */
    memset(obraz, 0, 320 * 200);
    memset(obraz + (HORNY_OKRAJ - 10) * 320, 0x69/*0x4d*/, 5 * 320);
    /* RESETOVANIE PREMENNYCH. */
    prehra = 0;
    vrychlost = 0;
    skok = 0;
    uz_nikdy_lopta = 0;
    duch = 1;
    rotacia_lopty = 0;
    spomalenie_rotacie = 0;
    spomalenie = 101;
    pocitadlo_s = 0;
    zopakovanie = 0;
    prekonane = 0;
    memset(x_klincov, 0, sizeof(x_klincov));
    memset(i_klincov, 0, sizeof(i_klincov));
    memset(typ_klincov, 0, sizeof(typ_klincov));
    nove_klince = 0;
    ak_zvuk = 0;
    hracove_i = (I_ZEME - VYSKA_HRACA) * 2;
    uplynuty_cas = 0;
    cyklus = 1;
    ako_na_to = 0;
    BosGetSystemTime(&stary_cas, &polnoc);
    if (menu)
    {
        x = 35;
        i = 60;
        velkost_znaku = 3;
        nakresliZnak(obraz, x, i, velkost_znaku, MODRA,
                  znakD);
        nakresliZnak(obraz, x + velkost_znaku * 7, i, velkost_znaku,
                  MODRA, znakL);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  MODRA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  MODRA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  MODRA, znakP);
        x = 60;
        i = 90;
        velkost_znaku = 2;
        nakresliZnak(obraz, x, i, velkost_znaku, ZELENA,
                  znakS);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZELENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  ZELENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  ZELENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  ZELENA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  ZELENA, znakJ);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  ZELENA, znakT);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  ZELENA, znakE);
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                  znakD);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZLTA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  ZLTA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  ZLTA, znakK);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  ZLTA, znakO);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  ZLTA, znakN);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  ZLTA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                  ZLTA, znakT);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                  ZLTA, znakO);
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, CERVENA,
                  znakM);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  CERVENA, znakK);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  CERVENA, znakO);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  CERVENA, znakN);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  CERVENA, znakI);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  CERVENA, znakE);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  CERVENA, znakC);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                      CERVENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                  CERVENA, znakY);
        memcpy(obrazovka, obraz, 320 * 200);
        BosGetSystemTime(&stary_cas, &polnoc);
        while (menu)
        {
            for (; uplynuty_cas; uplynuty_cas--)
            {
                hraj_zvuk(hudba2[ak_zvuk]);
                ak_zvuk = (ak_zvuk + 1) % 12;
                while (!BosReadKeyboardStatus(&kod, &znak))
                {
                    BosReadKeyboardCharacter(&kod, &znak);
                    if (znak == 'm')
                    {
                        menu = 0;
                        cyklus = 0;
                        koniec = 1;
                    }
                    else if (znak == 's') menu = 0;
                    else if (znak == 'z') prepni_zvuk(&zapnuty_zvuk);
                    if (znak == 'd')
                    {
                        menu = 0;
                        ako_na_to = 1;
                    }
                }
            }
            /* Kolko uplynulo casu za tento vykreslovaci cyklus? */
            BosGetSystemTime(&cas, &polnoc);
            if (cas < stary_cas) uplynuty_cas = cas; /* Asi bola polnoc... */
            else uplynuty_cas += cas - stary_cas;
            stary_cas = cas;
        }
    }
    BosGetSystemTime(&stary_cas, &polnoc);
    if (ako_na_to)
    {
        /* RESETOVANIE OBRAZOVKY */
        memset(obraz, 0, 320 * 200);
        memset(obraz + (HORNY_OKRAJ - 10) * 320, 0x69/*0x4d*/, 5 * 320);
        memset(obraz + (HORNY_OKRAJ - 6) * 320, FARBAP,
               320 * (200 - HORNY_OKRAJ + 6));
        x = 35;
        i = 60;
        velkost_znaku = 3;
        nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                  znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7, i, velkost_znaku,
                  ZLTA, znakK);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  ZLTA, znakO);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  ZLTA, znakN);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  ZLTA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  ZLTA, znakT);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 8, i, velkost_znaku,
                  ZLTA, znakO);
        x = 10;
        i = 90;
        velkost_znaku = 2;
        nakresliZnak(obraz, x, i, velkost_znaku, ZELENA,
                  znakS);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZELENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  ZELENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  ZELENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  ZELENA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  ZELENA, znakJ);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  ZELENA, znakT);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  ZELENA, znakE);
        i -= 4;
        x = x + velkost_znaku * 7 * 9 + velkost_znaku * 6;
        nakresliLuc(obraz, x, i);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1 + velkost_znaku * 3,
                     i, velkost_znaku,
                     CERVENA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      x + velkost_znaku * 7 * 2 + velkost_znaku * 3, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakP);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakE);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 8 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakA);
        i += 4;
        x = 10;
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                  znakS);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZLTA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*0,
                      x + velkost_znaku * 7 * 2, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakS);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakK);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakO);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakK);
        i += 2;
        x = x + velkost_znaku * 7 * 9 + velkost_znaku * 6;
        nakresliSolnyKrystal(obraz, x, i);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1 + velkost_znaku * 3,
                     i, velkost_znaku,
                     CERVENA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      x + velkost_znaku * 7 * 2 + velkost_znaku * 3, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakP);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakE);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 8 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakA);
        x = 10;
        i -= 2;
        i += velkost_znaku * 9 + 6;
        nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                  znakD);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZLTA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      x + velkost_znaku * 7 * 2, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakRovnaSa);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*0,
                      x + velkost_znaku * 7 * 4 + velkost_znaku * 4, i - 4);
        x = x + velkost_znaku * 7 * 4 + velkost_znaku + VYSKA_HRACA * 2;
        nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                  znakD);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  ZLTA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*0,
                      x + velkost_znaku * 7 * 2, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku, i, velkost_znaku,
                  ZLTA, znakRovnaSa);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      x + velkost_znaku * 7 * 4 + velkost_znaku * 4, i - 4);
        x = 10;
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, CERVENA,
                  znakM);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  CERVENA, znakK);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  CERVENA, znakO);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  CERVENA, znakN);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  CERVENA, znakI);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  CERVENA, znakE);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                  CERVENA, znakC);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                  CERVENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                  CERVENA, znakY);
        i -= 6;
        x = x + velkost_znaku * 7 * 13 + velkost_znaku * 6;
        nakresliKlinec(obraz, x, i);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1 + velkost_znaku * 3,
                     i, velkost_znaku,
                     CERVENA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*0,
                      x + velkost_znaku * 7 * 2 + velkost_znaku * 3, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      x + velkost_znaku * 7 * 3
                      + velkost_znaku * 4 + VYSKA_HRACA, i - 4);
        i += 6;
        x = 10;
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, MODRA,
                  znakP);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  MODRA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  MODRA, znakP);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  MODRA, znakA);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  MODRA, znakU);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  MODRA, znakZ);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                  MODRA, znakA);
        i += 6;
        x = x + velkost_znaku * 7 * 8 + velkost_znaku * 6;
        nakresliSolnyKrystal(obraz, x, i);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1 + velkost_znaku * 3,
                     i, velkost_znaku,
                     CERVENA, znakPlus);
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*0,
                      x + velkost_znaku * 7 * 2 + velkost_znaku * 3, i - 4);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakP);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakE);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 6 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakH);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 7 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakR);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 8 + VYSKA_HRACA
                  + velkost_znaku*4, i, velkost_znaku,
                  CERVENA, znakA);
        i -= 6;
        x = 10;
        i += velkost_znaku * 9;
        nakresliZnak(obraz, x, i, velkost_znaku, MODRA,
                  znakZ);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                  MODRA, znakRovnaSa);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                  MODRA, znakZ);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                  MODRA, znakV);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                  MODRA, znakU);
        nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                  MODRA, znakK);
        memcpy(obrazovka, obraz, 320 * 200);
        BosGetSystemTime(&stary_cas, &polnoc);
        while (ako_na_to)
        {
            for (; uplynuty_cas; uplynuty_cas--)
            {
                hraj_zvuk(hudba2[ak_zvuk]);
                ak_zvuk = (ak_zvuk + 1) % 12;
                while (!BosReadKeyboardStatus(&kod, &znak))
                {
                    BosReadKeyboardCharacter(&kod, &znak);
                    if (znak == 'm')
                    {
                        ako_na_to = 0;
                        cyklus = 0;
                        koniec = 1;
                    }
                    else if (znak == 's') ako_na_to = 0;
                    else if (znak == 'z') prepni_zvuk(&zapnuty_zvuk);
                }
            }
            /* Kolko uplynulo casu za tento vykreslovaci cyklus? */
            BosGetSystemTime(&cas, &polnoc);
            if (cas < stary_cas) uplynuty_cas = cas; /* Asi bola polnoc... */
            else uplynuty_cas += cas - stary_cas;
            stary_cas = cas;
        }
    }
    ak_zvuk = 0;
    BosGetSystemTime(&stary_cas, &polnoc);
    nakresliVzdialenost(obraz, prekonane, 2);
    while (cyklus)
    {
        skutocny_uplynuty_cas = uplynuty_cas;
        uplynuty_cas += zopakovanie;
        zopakovanie = 0;
        for (; uplynuty_cas; uplynuty_cas--)
        {
            if (uplynuty_cas <= skutocny_uplynuty_cas)
            {
                pocitadlo_s = (pocitadlo_s + 1) % 100;
                if (pocitadlo_s == spomalenie)
                {
                    zopakovanie += 1;
                    uplynuty_cas++;
                }
            }
            hraj_zvuk(hudba[ak_zvuk]);
            ak_zvuk = (ak_zvuk + 1) % 12;
            for (logicky_cyklus = 0; logicky_cyklus < 1; logicky_cyklus++)
            {
                while (!BosReadKeyboardStatus(&kod, &znak))
                {
                    BosReadKeyboardCharacter(&kod, &znak);
                    if (znak == 'm')
                    {
                        cyklus = 0;
                        koniec = 1;
                    }
                    else if (kod == 0x50) ; /* Dole. */
                    else if (kod == 0x4b) ; /* Vlavo. */
                    else if (kod == 0x4d) ; /* Vpravo. */
                    else if (kod == 0x48) ; /* Hore. */
                    else if (znak == 's')
                    {
                        if (!duch && !skok)
                        {
                            vrychlost = -23;
                            skok = 1;
                        }
                    }
                    else if (znak == 'd' && !uz_nikdy_lopta) duch = !duch;
                    else if (znak == 'z') prepni_zvuk(&zapnuty_zvuk);
                    else if (znak == 'p') prestavka = 1;
                }
                for (a = 0; a < POCET_KLINCOV; a++)
                {
                    if (i_klincov[a])
                    {
                        x_klincov[a] += r_klincov;
                        if (x_klincov[a] + DLZKA_ZLYCH * 2 >= 320)
                        {
                            i_klincov[a] = 0;
                        }
                        if (typ_klincov[a])
                        {
                            if (x_klincov[a] + DLZKA_ZLYCH*2 - 3 > HRACOVE_X &&
                                (x_klincov[a] + DLZKA_ZLYCH*2 - 3 <
                                 HRACOVE_X + VYSKA_HRACA) &&
                                i_klincov[a] + DLZKA_ZLYCH / 2 > hracove_i/2
                                + 2
                                &&
                                (i_klincov[a] + DLZKA_ZLYCH / 2 - 1 <
                                 hracove_i/2 + VYSKA_HRACA - 2))
                            {
                                if (typ_klincov[a] == 1 && !duch)
                                {
                                    duch = 1;
                                    uz_nikdy_lopta = 1;
                                }
                                else if((typ_klincov[a] == 2 && duch)
                                        || typ_klincov[a] == 3)
                                {
                                    /* PREHRA */
                                    cyklus = 0;
                                    prehra = 1;
                                }
                            }
                        }
                    }
                    else
                    {
                        i_klincov[a] = HORNY_OKRAJ + a * (DLZKA_ZLYCH + 1);
                        x_klincov[a] = 0;
                        typ_klincov[a] = (unsigned int) rand() % 3 + 1;
                        nove_klince = 1;
                    }
                }
                if (nove_klince)
                {
                    a = 1 + (unsigned int) rand() % (POCET_KLINCOV - 3 - 1);
                    typ_klincov[a] = 0;
                    typ_klincov[a + 1] = 0;
                    typ_klincov[a + 2] = 0;
                    nove_klince = 0;
                    if (spomalenie > 2) spomalenie -= 1;
                    if (spomalenie != 100)
                    {
                        prekonane++;
                        nakresliVzdialenost(obraz, prekonane, 2);
                    }
                }
                if (!duch)
                {
                    if (skok)
                    {
                        hracove_i += vrychlost;
                        vrychlost++;
                        if (hracove_i + VYSKA_HRACA * 2 >= I_ZEME * 2)
                        {
                            skok = 0;
                            vrychlost = 0;
                        }
                    }
                }
                else
                {

                }
            }
            if (!duch)
            {
                spomalenie_rotacie = (spomalenie_rotacie + 1) % 5;
                if (!spomalenie_rotacie)
                    rotacia_lopty = (rotacia_lopty + 1) % 4;
            }
        }
        if (prestavka)
        {
            /* Vypne sa zvuk. */
            a = 1;
            prepni_zvuk(&a);
            x = 35;
            i = 60;
            velkost_znaku = 3;
            nakresliZnak(obraz, x, i, velkost_znaku, MODRA,
                      znakP);
            nakresliZnak(obraz, x + velkost_znaku * 7, i, velkost_znaku,
                      MODRA, znakA);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      MODRA, znakU);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      MODRA, znakZ);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      MODRA, znakA);
            x = 60;
            i = 90;
            velkost_znaku = 2;
            nakresliZnak(obraz, x, i, velkost_znaku, ZELENA,
                      znakP);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                      ZELENA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      ZELENA, znakH);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      ZELENA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      ZELENA, znakA);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      ZELENA, znakJ);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                      ZELENA, znakT);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                      ZELENA, znakE);
            i += velkost_znaku * 9;
            nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                      znakD);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                      ZLTA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      ZLTA, znakM);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      ZLTA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      ZLTA, znakN);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      ZLTA, znakU);
            i += velkost_znaku * 9;
            nakresliZnak(obraz, x, i, velkost_znaku, CERVENA,
                      znakM);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                      CERVENA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      CERVENA, znakK);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      CERVENA, znakO);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      CERVENA, znakN);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      CERVENA, znakI);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                      CERVENA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                      CERVENA, znakC);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                      CERVENA, znakH);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                      CERVENA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                      CERVENA, znakY);
            memcpy(obrazovka, obraz, 320 * 200);
            while (prestavka)
            {
                while (!BosReadKeyboardStatus(&kod, &znak))
                {
                    BosReadKeyboardCharacter(&kod, &znak);
                    if (znak == 'm')
                    {
                        prestavka = 0;
                        cyklus = 0;
                        koniec = 1;
                    }
                    else if (znak == 'p') prestavka = 0;
                    if (znak == 'd')
                    {
                        prestavka = 0;
                        cyklus = 0;
                        menu = 1;
                    }
                }
            }
            /* Ak bol zvuk zapnuty, znova sa zapne. */
            if (zapnuty_zvuk) prepni_zvuk(&a);
            BosGetSystemTime(&stary_cas, &polnoc);
        }
        memset(obraz + (HORNY_OKRAJ - 6) * 320, FARBAP,
               320 * (200 - HORNY_OKRAJ + 6));
        memset(obraz + I_ZEME * 320, 9, 320 * 10);
        if (!duch)
        nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*rotacia_lopty,
                      HRACOVE_X, hracove_i  / 2);
        else nakresliLoptu(obraz, lopta + VYSKA_HRACA*VYSKA_HRACA*4,
                      HRACOVE_X, hracove_i  / 2);

        for (a = 0; a < POCET_KLINCOV; a++)
        {
            if (i_klincov[a])
            {
                if (typ_klincov[a] == 1)
                    nakresliKlinec(obraz, x_klincov[a], i_klincov[a]);
                else if (typ_klincov[a] == 2)
                    nakresliLuc(obraz, x_klincov[a], i_klincov[a]);
                else if (typ_klincov[a] == 3)
                    nakresliSolnyKrystal(obraz, x_klincov[a], i_klincov[a]);
            }
        }

        /* Prekopiruje bafer do video pamete. */
        memcpy(obrazovka, obraz, 320 * 200);

        /* Kolko uplynulo casu za tento vykreslovaci cyklus? */
        BosGetSystemTime(&cas, &polnoc);
        if (cas < stary_cas) uplynuty_cas = cas; /* Asi bola polnoc... */
        else uplynuty_cas += cas - stary_cas;
        stary_cas = cas;
    }
    cyklus = 1;
    a = 0;
    plnenie = 1;
    while (prehra)
    {
        for (; uplynuty_cas; uplynuty_cas--)
        {
            /*hraj_zvuk(hudba[ak_zvuk]);
            ak_zvuk = (ak_zvuk + 1) % 12;*/
            for (logicky_cyklus = 0; logicky_cyklus < 1; logicky_cyklus++)
            {
                while (!BosReadKeyboardStatus(&kod, &znak))
                {
                    BosReadKeyboardCharacter(&kod, &znak);
                    if (znak == 'm')
                    {
                        prehra = 0;
                        koniec = 1;
                    }
                    else if (znak == 'z') prepni_zvuk(&zapnuty_zvuk);
                    else if (znak == 'd')
                    {
                        prehra = 0;
                        menu = 1;
                    }
                    else if (znak == 's')
                    {
                        prehra = 0;
                    }
                }
                if (plnenie)
                {
                    memset(obraz + (HORNY_OKRAJ - 6 + a) * 320, 0x23, 320);
                    memset(obraz + (199 - a) * 320, 0x23, 320);
                    a++;
                    if (a == (200 - HORNY_OKRAJ + 6) / 2 + 1)
                    {
                        plnenie = 0;
                        cyklus = 1;
                    }
                }
            }
        }
        if (cyklus)
        {
            x = 35;
            i = 60;
            velkost_znaku = 3;
            nakresliZnak(obraz, x, i, velkost_znaku, CERVENA,
                      znakP);
            nakresliZnak(obraz, x + velkost_znaku * 7, i, velkost_znaku,
                      CERVENA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      CERVENA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      CERVENA, znakH);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      CERVENA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      CERVENA, znakA);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                      CERVENA, znakL);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                      CERVENA, znakI);
            /* medzera */
            nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                      CERVENA, znakS);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                      CERVENA, znakT);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                      CERVENA, znakE);
            x = 60;
            i = 90;
            velkost_znaku = 2;
            nakresliZnak(obraz, x, i, velkost_znaku, ZELENA,
                      znakS);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                          ZELENA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      ZELENA, znakH);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      ZELENA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      ZELENA, znakA);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      ZELENA, znakJ);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                      ZELENA, znakT);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                      ZELENA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                      ZELENA, znakZ);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                      ZELENA, znakN);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                      ZELENA, znakO);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 12, i, velkost_znaku,
                      ZELENA, znakV);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 13, i, velkost_znaku,
                      ZELENA, znakA);
            i += velkost_znaku * 9;
            nakresliZnak(obraz, x, i, velkost_znaku, ZLTA,
                      znakD);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                      ZLTA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      ZLTA, znakM);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      ZLTA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      ZLTA, znakN);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      ZLTA, znakU);
            i += velkost_znaku * 9;
            nakresliZnak(obraz, x, i, velkost_znaku, MODRA,
                      znakM);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 1, i, velkost_znaku,
                      MODRA, znakRovnaSa);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 2, i, velkost_znaku,
                      MODRA, znakK);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 3, i, velkost_znaku,
                      MODRA, znakO);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 4, i, velkost_znaku,
                      MODRA, znakN);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 5, i, velkost_znaku,
                      MODRA, znakI);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 6, i, velkost_znaku,
                      MODRA, znakE);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 7, i, velkost_znaku,
                      MODRA, znakC);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 9, i, velkost_znaku,
                      MODRA, znakH);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 10, i, velkost_znaku,
                      MODRA, znakR);
            nakresliZnak(obraz, x + velkost_znaku * 7 * 11, i, velkost_znaku,
                      MODRA, znakY);
            /* Prekopiruje bafer do video pamete. */
            memcpy(obrazovka, obraz, 320 * 200);
            cyklus = 0;
        }

        /* Kolko uplynulo casu za tento vykreslovaci cyklus? */
        BosGetSystemTime(&cas, &polnoc);
        if (cas < stary_cas) uplynuty_cas = cas; /* Asi bola polnoc... */
        else uplynuty_cas += cas - stary_cas;
        stary_cas = cas;
    }
    }
    zapnuty_zvuk = 1;
    prepni_zvuk(&zapnuty_zvuk);
    free(obraz);
    free(lopta);

    BosSetVideoMode(0x3);
    return (0);
}
